#!/usr/bin/env kjscmd

// KONKURRENCY 0.9.2

// LICENSE: GPL
// Copyright: Håvard Dahle, havard@dahle.no, 2004

function Konkurrency(ui) 
{
    this.ui = ui;
    var amountIn = ui.child('amountIn');
    this.amountIn = amountIn;
    var currencyIn = ui.child('currencyIn');
    this.currencyIn = currencyIn;
    var currencyOut = ui.child('currencyOut');
    this.currencyOut = currencyOut;
    
    this.calculate = function()
    {
        var out = amountIn.text /
            this.convKey[currencyIn.currentText] *
            this.convKey[currencyOut.currentText];
        this.ui.child("amountOut").setText(out);
    }
    
    this.populate = function(key)
    {
        for (var z in key) {
            currencyIn.insertItem(z);
            currencyOut.insertItem(z);
        }

        this.convKey = key;

        ui.connect( ui.child('calculate'), 'clicked()', this, 'calculate' );
        ui.connect( this.currencyIn, 'activated(int)', this, 'calculate' );
        ui.connect( this.currencyOut, 'activated(int)', this, 'calculate' );
    }
}

function loadRates()
{
    var net = new NetAccess( null, 'net' );
    var tmp = '/tmp/rates.xml';
    var ratesUrl = 'http://www.ecb.int/stats/eurofxref/eurofxref-daily.xml';
    var ret = net.download( ratesUrl, tmp );

    if (! ret ) {
        // loading failed, return default
        return { "EUR" : 1.0,
                 "USD" : 1.2413,
                 "GBP" : 0.69095,
                 "NOK" : 8.3280
               }
    } else {
        var f = System.readFile(tmp).split("\n");
        var key = { "EUR" : 1.0 }; // All rates quoted against the Euro
        var h;

        var rc = /Cube currency=.([A-Z]{3}). rate='([\d.]+)'/;
        for(var x = f.length-3; x > 0; x--) {
            try {
                h = rc.exec(f[x]);
                key[h[1]] = h[2];
            } catch(e) {}
        }
        return key;
    }
}

var ui = Factory.loadui('konkurrency.ui');
var konkurrency = new Konkurrency(ui);

konkurrency.populate(loadRates());

ui.show();
application.exec();
